EclaireXL - Bug #6

HDMI audio poor quality
04/04/2017 09:06 PM - admin

Status: Closed Start date: 04/04/2017
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0:00 hour
Target version:

Description
| removed a low division in the audio output to meet timing. | suspect this should be replaced with a proper low pass filter.

Related issues:

Related to Bug #31: HDMI Audio generate high pitch noise (Core 8) Closed 06/01/2017
Related to Bug #69: Some TVs confused by hdmi audio New 06/07/2018
History

#1 - 06/02/2017 07:09 AM - foft
- Related to Bug #31: HDMI Audio generate high pitch noise (Core 8) added

#2 - 05/28/2018 09:49 PM - foft

1. Is the time between this always the same? If so can dls the sound quality poor because | removed the divide?
2. If so, does the divide happen at a consistent period? If so | can scale/multiply then divide by power of two.
3. Or is the sound quality poor because | just got signed/unsigned wrong?

| guess | can simply generate/feed in a signed/unsigned sine wave and see what comes out to start with...

#3 - 06/02/2018 08:01 PM - foft

The biggest issue with this appears to be that | need to send signed samples. Changed that and its sounding much better.

#4 - 06/03/2018 08:35 PM - foft

Investigating resampling high frequencies to 48KHz with some plots in Octave. The average that | removed wasn't a bad simple low pass filter
(though didn't meet timing...). The way | did it (just sample) sucks, quite frankly. Any high frequency noise is aliased down to a nice squeal.
Investigating some simple 'fpga-friendly’ options in Octave.

#5 - 06/04/2018 09:58 PM - foft

- File filter_performance.png added

Trying out various options in Octave.

sample = current method (just take the current value), flat line at top!

mean = mean of last n samples (which did not meet timing due to expensive division)

meanfpga = mean of last 32 samples (easy division)

diff3 = at 1.79MHz apply: out = out + (in-out)*3/(48000/1790000)

difffpga = at 1.79MHz apply: out = out + (in-out)/16 (i.e. like 1st order RC filter)

difffpga2 = at 1.79MHz apply: out = out + (in-out)/16, then out = out + (in-out)/8 (i.e. like 2nd order RC filter)

Planning to use difffpga2, just a subtract and addition and bit shift or two.

05/05/2025 12




F'\gure 37

Grslemeaeaala?

Simple filter options

0 | \
'— mean
20 _ — diff3 |
meanfpga
difffpga
. 40 difffpga2
o
Z
c -60 —
Q
g
c -80 —
QL
< 400 _
-120 —
-140 L | \ | \
101 102 103 104 105
Frequency(Hz)

10054.0, -85.3540

#6 - 06/04/2018 10:00 PM - foft

Could look into FIR and IIR filters, but to be honest this seems very lightweight and to work well. Will implement and see what it sounds like!

#7 - 06/05/2018 09:07 PM - foft

Wired this up and sounding much better.

Unfortunately @Farb seems to have completely different symptoms! https://photos.app.goo.gl/c3VMPp0XY7nladBG3. Here jumpman is sounding

good, even before the filter.

#8 - 06/07/2018 06:42 AM - foft

- Status changed from New to Closed

#9 - 06/07/2018 06:44 AM - foft

- Related to Bug #69: Some TVs confused by hdmi audio added
